% locations
loc(home).
loc(airport).
gate(gateA).
gate(gateB).
loc(X) :- gate(X).

plane(f123).

% fluents
fluent(at(L)) :-
	loc(L).
fluent(on_plane(P)) :-
	plane(P).
fluent(parked(P,G)) :-
	plane(P), gate(G).

% actions
action(go(L)) :-
	loc(L).
action(board_plane(P)) :-
	plane(P).
action(check_departures).

% executability conditions
executable(go(airport),[at(home)]).
executable(go(G),[at(airport)]) :-
	gate(G).
executable(board_plane(P),[at(G),parked(P,G)]) :-
	plane(P), gate(G).
executable(check_departures,[at(airport)]).

% dynamic laws
causes(go(L),at(L),[]) :-
	loc(L).
causes(board_plane(P),on_plane(P),[]) :-
	plane(P).
determines(check_departures,
	[parked(P,gateA),parked(P,gateB)]) :-
	plane(P).

% static laws
oneof(Ls) :-
	findall(at(L),loc(L),Ls).
oneof([parked(P,gateA),parked(P,gateB)]) :-
	plane(P).

% initial state
initially(at(home)).

% goal
goal(on_plane(f123)).