% blks
blk(b0).
blk(b1).
blk(b2).
blk(b3).
blk(b4).
blk(b5).
blk(b6).
blk(b7).
blk(b8).
blk(b9).
blk(b10).


% locations
loc(table).
loc(B) :- 
	blk(B).

% fluents
fluent(on(B,L)) :-
	blk(B), loc(L).
fluent(occupied(B)) :- 
	loc(B).

% actions
% move a blk to another place (on another blk
% or on the table)
action(move(B,L)) :-
	blk(B), loc(L).

% executability conditions
executable(move(B,L),[neg(occupied(B)),neg(occupied(L))]) :-
	blk(B), loc(L), B \== L.

% dynamic laws
causes(move(B,L),on(B,L),[]) :-
	blk(B), loc(L).
causes(move(B,L),neg(on(B,L1)),[on(B,L1)]) :-
	blk(B), loc(L), loc(L1), L \== L1.
causes(move(B,L),neg(occupied(L1)),[on(B,L1)]) :-
	blk(B), loc(L), loc(L1), L \== L1.

% static laws
caused(occupied(B),[on(B1,B)]) :-
	blk(B), blk(B1).

% initial state
initially(neg(occupied(table))).

initially(on(b0,table)).
initially(on(b1,b0)).
initially(on(b2,b1)).
initially(neg(occupied(b2))).

initially(on(b3,table)).
initially(on(b4,b3)).
initially(on(b9,b4)).
initially(on(b10,b9)).
initially(neg(occupied(b10))).

initially(on(b5,table)).
initially(on(b6,b5)).
initially(on(b7,b6)).
initially(on(b8,b7)).
initially(neg(occupied(b8))).

% goal
goal(on(b9,table)).
goal(on(b4,b9)).
goal(on(b0,b4)).

goal(on(b3,table)).
goal(on(b8,b3)).
goal(on(b7,b8)).

goal(on(b5,table)).
goal(on(b6,b5)).
goal(on(b10,b6)).
goal(on(b2,b10)).
goal(on(b1,b2)).
