% locations
loc(1).
loc(2).
loc(3).

disk(0).
disk(1).
disk(2).
disk(3).
disk(4).

% fluents
fluent(on(D,L)) :-
    disk(D), loc(L).

fluent(clear(L)) :-
    loc(L).

fluent(top(D,L)) :-
    disk(D), loc(L).

% actions
action(move(D,L)) :-
    disk(D), loc(L).

% executability conditions
executable(move(D,L),[top(D1,L)]) :-
    disk(D), disk(D1), D > D1.

% dynamic laws
causes(move(D,L),on(D,L),[]) :-
    disk(D), loc(L).

causes(move(D,L),top(D,L),[]) :-
    disk(D), loc(L).

% static laws
oneof([on(D,1),on(D,2),on(D,3)]) :-
    disk(D), D \== 0.

% initial state
initially(on(D,1)) :-
    disk(D).
initially(on(0,2)).
initially(on(0,3)).
initially(top(4,1)).
initially(top(0,2)).
initially(top(0,3)).

% goal
goal(on(D,2)) :-
    disk(D).
