% File 'mbp.c'
% Domain: Monkey and Bananas ("Nonmonotonic Causal Theories," Figures  10-12)

:- sorts
  thing;
  location.

:- objects
  monkey, bananas, box     :: thing;
  l1,l2,l3                 :: location.

:- variables
  L                        :: location.

:- constants
  loc(thing)               :: inertialFluent(location);
  hasBananas, on_box       :: inertialFluent;

  walk(location),
  push_box(location),
  climb_box,
  graspBananas           :: exogenousAction.

caused loc(bananas)=L if hasBananas & loc(monkey)=L.
caused loc(monkey)=L if on_box & loc(box)=L.

walk(L) causes loc(monkey)=L.
nonexecutable walk(L) if loc(monkey)=L.
nonexecutable walk(L) if on_box.

push_box(L) causes loc(box)=L.
push_box(L) causes loc(monkey)=L.
nonexecutable push_box(L) if loc(monkey)=L.
nonexecutable push_box(L) if on_box.
nonexecutable push_box(L) if loc(monkey) \= loc(box).

climb_box causes on_box.
nonexecutable climb_box if on_box.
nonexecutable climb_box if loc(monkey)\=loc(box).

graspBananas causes hasBananas.
nonexecutable graspBananas if hasBananas.
nonexecutable graspBananas if -on_box.
nonexecutable graspBananas if loc(monkey)\=loc(bananas).

nonexecutable walk(L) & push_box(L).
nonexecutable walk(L) & climb_box.
nonexecutable push_box(L) & climb_box.

:- query
maxstep :: 1..10;
0: loc(monkey)=l1,
  loc(box)=l2,
   loc(bananas)=l3;
maxstep: hasBananas.
