% packages
pkg(p1).
pkg(p2).
pkg(p3).
pkg(p4).

% fluents
fluent(armed(P)) :-
    pkg(P).

fluent(clogged).

fluent(dunked(P)) :-
	pkg(P).

fluent(disarmed).

% actions
action(dunk(P)) :-
    pkg(P).

action(detect_metal(P)) :-
	pkg(P).

% executability conditions
executable(dunk(P),[neg(clogged),neg(dunked(P))]) :-
    pkg(P).

executable(detect_metal(P),[neg(dunked(P))]) :-
    pkg(P).

% dynamic laws
causes(dunk(P),neg(armed(P)),[]) :-
    pkg(P).

causes(dunk(P),dunked(P),[]) :-
    pkg(P).

causes(dunk(P),clogged,[]) :-
    pkg(P).

determines(detect_metal(P),[armed(P),neg(armed(P))]) :-
	pkg(P).

% static laws
caused(disarmed,L) :-
    findall(neg(armed(P)),pkg(P),L).

% initial state
initially(neg(dunked(P))) :-
    pkg(P).

% one of packages is armed
initially(neg(disarmed)).

% goal
goal(disarmed).