% packages
pkg(p1).
pkg(p2).
pkg(p3).
pkg(p4).
pkg(p5).
pkg(p6).
pkg(p7).
pkg(p8).

toilet(t1).
toilet(t2).

% fluents
fluent(armed(P)) :-
	pkg(P).
fluent(dunked(P)) :-
	pkg(P).
fluent(disarmed).

% actions
action(dunk(P,T)) :-
	pkg(P), toilet(T).

% executability conditions
executable(dunk(P,T),[neg(dunked(P))]) :-
	pkg(P), toilet(T).

% dynamic laws
causes(dunk(P,T),neg(armed(P)),[]) :-
	pkg(P), toilet(T).
causes(dunk(P,T),dunked(P),[]) :-
	pkg(P), toilet(T).

% static laws
caused(disarmed,L) :-
	findall(neg(armed(P)),pkg(P),L).

% initial state
initially(neg(dunked(P))) :-
	pkg(P).

initially(neg(disarmed)).

% goal
goal(disarmed).