% Hanoi Towers
%   Loc 1      <Disk 1>
%   Loc 2      <Disk 2>
%   Loc 3      <Disk 3>
%   Loc 4      <Disk 4>
%                Peg 1             Peg 2            Peg 3


% number of disks
disk(1..4).

% three pegs
peg(1).
peg(2).
peg(3).

% locations
loc(L) :- 
	disk(L).

% fluents
fluent(peg(P)) :- peg(P).

% loc(D,L) = true if disk D is at location L
fluent(loc(D,L)) :- 
	loc(L).

% actions
% move the top disk from one peg to another
action(move(P,P1)) :- 
	peg(P), peg(P1).

% dynamic laws
causes(move(P,P1),loc(D,L)

