% This is a variation of the Yale Shooting Problem 
% from (Hanks and McDermott 1987). In this example,
% a new sensing action check is used to determine
% the status of the gun.

% fluents
fluent(alive).
fluent(loaded).

% actions
action(load).
action(shoot).
action(check).

% executability conditions
executable(shoot,[loaded]).
executable(load,[neg(loaded)]).
executable(check,[]).

% dynamic laws
causes(shoot,neg(alive),[]).
causes(shoot,neg(loaded),[]).
causes(load,loaded,[]).

% k-propositions
determines(check,[loaded,neg(loaded)]).

% initial state
initially(alive).

% goal
goal(neg(alive)).
