:- prolog_flag(redefine_warnings,_,off). 

:- consult(tr4).

go :- trans_classical, trans_conform, trans_cond.

% translate classical planning examples
trans_classical :-
	gen('mbp.pl','mbp.smo'),
	gen('blw1.pl','blw1.smo'),
	gen('blw2.pl','blw2.smo'),
	gen('blw3.pl','blw3.smo'),
	gen('blw4.pl','blw4.smo'),
	gen('blw5.pl','blw5.smo').

% translate conformant planning problems
trans_conform :-
	gen('bt_2.pl','bt_2.smo'),
	gen('bt_4.pl','bt_4.smo'),
	gen('bt_6.pl','bt_6.smo'),
	gen('bt_8.pl','bt_8.smo'),
	gen('bt_10.pl','bt_10.smo'),
	gen('bmt_2_2.pl','bmt_2_2.smo'),
	gen('bmt_4_2.pl','bmt_4_2.smo'),
	gen('bmt_6_2.pl','bmt_6_2.smo'),
	gen('bmt_8_4.pl','bmt_8_4.smo'),
	gen('bmt_10_4.pl','bmt_10_4.smo'),
	gen('btc_2.pl','btc_2.smo'),
	gen('btc_4.pl','btc_4.smo'),
	gen('btc_6.pl','btc_6.smo'),
	gen('btc_8.pl','btc_8.smo'),
	gen('btc_10.pl','btc_10.smo'),
	gen('bmtc_2_2.pl','bmtc_2_2.smo'),
	gen('bmtc_4_2.pl','bmtc_4_2.smo'),
	gen('bmtc_6_2.pl','bmtc_6_2.smo'),
	gen('bmtc_8_4.pl','bmtc_8_4.smo'),
	gen('bmtc_10_4.pl','bmtc_10_4.smo'),
	gen('btuc_2.pl','btuc_2.smo'),
	gen('btuc_4.pl','btuc_4.smo'),
	gen('btuc_6.pl','btuc_6.smo'),
	gen('btuc_8.pl','btuc_8.smo'),
	gen('btuc_10.pl','btuc_10.smo'),
	gen('bmtuc_2_2.pl','bmtuc_2_2.smo'),
	gen('bmtuc_4_2.pl','bmtuc_4_2.smo'),
	gen('bmtuc_6_2.pl','bmtuc_6_2.smo'),
	gen('bmtuc_8_4.pl','bmtuc_8_4.smo'),
	gen('bmtuc_10_4.pl','bmtuc_10_4.smo').

% translate contingent planning problems
trans_cond :-
	gen('ap.pl','ap.smo'),
	gen('ysp.pl','ysp.smo'),
	gen('bd.pl','bd.smo'),
	gen('bts1_2.pl','bts1_2.smo'),
	gen('bts1_4.pl','bts1_4.smo'),
	gen('bts1_6.pl','bts1_6.smo'),
	gen('bts1_8.pl','bts1_8.smo'),
	gen('bts1_10.pl','bts1_10.smo'),
	gen('bts2_2.pl','bts2_2.smo'),
	gen('bts2_4.pl','bts2_4.smo'),
	gen('bts2_6.pl','bts2_6.smo'),
	gen('bts2_8.pl','bts2_8.smo'),
	gen('bts2_10.pl','bts2_10.smo'),
	gen('bts3_2.pl','bts3_2.smo'),
	gen('bts3_4.pl','bts3_4.smo'),
	gen('bts3_6.pl','bts3_6.smo'),
	gen('bts3_8.pl','bts3_8.smo'),
	gen('bts3_10.pl','bts3_10.smo'),
	gen('bts4_2.pl','bts4_2.smo'),
	gen('bts4_4.pl','bts4_4.smo'),
	gen('bts4_6.pl','bts4_6.smo'),
	gen('bts4_8.pl','bts4_8.smo'),
	gen('bts4_10.pl','bts4_10.smo'),
	gen('med1.pl','med1.smo'),
	gen('med2.pl','med2.smo'),
	gen('med3.pl','med3.smo'),
	gen('med4.pl','med4.smo'),
	gen('med5.pl','med5.smo').
