% This is the Bomb defusion problem from
% (Son & Baral 2000)

% fluents
fluent(dead).
fluent(disarmed).
fluent(exploded).
fluent(locked).

% actions
action(disarm).
action(turn).
action(look).

% executability conditions
executable(disarm,[neg(exploded),neg(dead)]).
executable(turn,[neg(exploded),neg(dead)]).
executable(look,[neg(exploded),neg(dead)]).

% dynamic laws
causes(disarm,exploded,[neg(locked)]).
causes(disarm,disarmed,[locked]).
causes(turn,neg(locked),[locked]).
causes(turn,locked,[neg(locked)]).

% knowledge-producing laws
determines(look,[locked,neg(locked)]).

% static laws
caused(dead,[exploded]).

% initial state
initially(neg(dead)).
initially(neg(disarmed)).
initially(neg(exploded)).

% goal
goal(neg(dead)).
goal(disarmed).
