% packages
pkg(p1).
pkg(p2).

toilet(t1).
toilet(t2).

% fluents
fluent(armed(P)) :-
	pkg(P).
fluent(dunked(P)) :-
	pkg(P).
fluent(clogged(T)) :-
	toilet(T).
fluent(disarmed).

% actions
action(dunk(P,T)) :-
	pkg(P), toilet(T).
action(flush(T)) :-
	toilet(T).

% executability conditions
executable(dunk(P,T),[neg(dunked(P)),neg(clogged(T))]) :-
	pkg(P), toilet(T).
executable(flush(T),[]) :-
	toilet(T).

% dynamic laws
causes(dunk(P,T),neg(armed(P)),[]) :-
	pkg(P), toilet(T).
causes(dunk(P,T),dunked(P),[]) :-
	pkg(P), toilet(T).
causes(dunk(P,T),clogged(T),[]) :-
	pkg(P), toilet(T).

causes(flush(T),neg(clogged(T)),[]) :-
	toilet(T).

% static laws
caused(disarmed,L) :-
	findall(neg(armed(P)),pkg(P),L).

% initial state
initially(neg(dunked(P))) :-
	pkg(P).

% goal
goal(disarmed).
