% This is the encoding for the Bomb In the Toilet
% with Sensing Actions problem from (Weld et al. 1998)

% packages
pkg(p1).
pkg(p2).

% fluents
fluent(armed(P)) :-
    pkg(P).

fluent(clogged).

fluent(dunked(P)) :-
    pkg(P).

fluent(disarmed).

% actions
action(dunk(P)) :-
    pkg(P).

action(detect_metal(P)) :-
    pkg(P).

action(sniff(P)) :-
    pkg(P).

% executability conditions
executable(dunk(P),[neg(clogged),neg(dunked(P))]) :-
    pkg(P).

executable(detect_metal(P),[neg(dunked(P))]) :-
    pkg(P).

executable(sniff(P),[neg(dunked(P))]) :-
    pkg(P).

% dynamic laws
causes(dunk(P),neg(armed(P)),[]) :-
    pkg(P).

causes(dunk(P),dunked(P),[]) :-
    pkg(P).

causes(dunk(P),clogged,[]) :-
    pkg(P).

determines(detect_metal(P),[armed(P),neg(armed(P))]) :-
    pkg(P).

determines(sniff(P),[armed(P),neg(armed(P))]) :-
    pkg(P).

% static laws
caused(disarmed,L) :-
    findall(neg(armed(P)),pkg(P),L).

caused(neg(armed(P)),[armed(P1)]) :-
    pkg(P), pkg(P1), P \== P1.

% initial state
initially(neg(dunked(P))) :-    % no package is dunked
    pkg(P).
initially(neg(disarmed)).       % one of packages is armed
initially(neg(clogged)).        % the toilet is not clogged

% goal
goal(disarmed).
