;; AIRPORT domain: from Levesque 1996

(in-package :domains)

(define (domain ap)
  (:requirements :strips :equality :typing :conditional-effects :uncertainty)
  (:action drive
	   :parameters ()
	   :precondition (at home)
	   :effect (at airport))

  (:action walk
	   :parameters (?l2)
	   :precondition (and (location ?l1) (location ?l2)
						  (at ?l1) (not (= ?l1 ?l2)))
	   :effect (and (at ?l2) (not (at ?l1))))

  (:action board_plane
	   :parameters (?p ?g)
	   :precondition (and (plane ?p) (gate ?g)
			      (at ?g) (parked ?p ?g))
	   :effect (on_plane ?p))

  (:action check_departures
	   :parameters ()
	   :precondition (and (plane ?p) (gate ?g))
	   :effect (observes (parked ?p ?g))))

;; Problem: AP
(define (problem ap)
  (:domain ap)
  (:objects gateA gateB home airport f123)
  (:init (gate gateA) (gate gateB) 
		 (location gateA) (location gateB) (location airport)
		 (plane f123) (at home)
		 (oneof (parked f123 gateA) (parked f123 gateB))
   )
  (:goal (on_plane f123)))