;; Bomb defusion: from Son et al 2001

(in-package :domains)

(define (domain bd)
  (:requirements :strips :conditional-effects :uncertainty :sensing)
  (:action turn
	   :parameters ()
	   :precondition (and (not (exploded)) (not (dead)))
	   :effect (and (when (locked) (not (locked)))
					(when (not (locked)) (locked))))

  (:action disarm
	   :parameters ()
	   :precondition (and (not (exploded)) (not (dead)))
	   :effect (and (when (locked) (defused))
					(when (not (locked)) (exploded))))

  (:action look
	   :parameters ()
	   :precondition (and (not (exploded)) (not (dead)))
	   :effect (observes (locked))
  )
)

;; Problem: BD
(define (problem bd)
  (:domain bd)
  (:init (not (exploded)) (not (dead))
		 (oneof (locked) (not (locked)))
		 (iff (exploded) (dead)))
  (:goal (and (locked) (defused) (not (exploded)))))