(in-package :domains)

(define (domain blw)
  (:requirements :strips :equality :conditional-effects)
  (:action move
	     :parameters (?B ?L1 ?L2)
	     :precondition (and (block ?B) (location ?L1) (location ?L2)
							(not (= ?B ?L1)) (not (= ?B ?L2))
							(not (= ?L1 ?L2)) (on ?B ?L1)
							(not (occupied ?B)) (not (occupied ?L2)))
	     :effect
	     (and (on ?B ?L2) (not (occupied ?L1)) (not (on ?B ?L1))
			  (when (not (= ?L2 table)) (occupied ?L2)))))

;; 4 blocks, 4 steps
(define (problem blw1)
  (:domain blw)
  (:objects 1 2 3 4 table)
  (:init (block 1) (block 2) (block 3) (block 4)
		 (location 1) (location 2) 
		 (location 3) (location 4) 
		 (location table)
		 (on 1 table) (on 2 table) 
		 (on 3 table) (on 4 3)
		 (not (occupied 1)) (not (occupied 2))
		 (not (occupied 4)))
  (:goal (and (on 1 table) (on 2 1) (on 3 2) (on 4 3))))

;; 5 blocks, 6 steps
(define (problem blw2)
  (:domain blw)
  (:objects 1 2 3 4 5 table)
  (:init (block 1) (block 2) (block 3) (block 4) (block 5)
		 (location 1) (location 2) 
		 (location 3) (location 4) (location 5)
		 (location table) 
		 (on 1 4) (on 2 5) 
		 (on 3 table) (on 4 3) (on 5 3)
		 (not (occupied 1)) (not (occupied 2)))
  (:goal (and (on 1 table) (on 2 1) 
			  (on 3 2) (on 4 3) (on 5 4))))

;; 8 blocks, 8 steps
(define (problem blw3)
  (:domain blw)
  (:objects 1 2 3 4 5 6 7 8 table)
  (:init (block 1) (block 2) (block 3) (block 4) 
		 (block 5) (block 6) (block 7) (block 8)
		 (location 1) (location 2) (location 3) 
		 (location 4) (location 5) (location 6) 
		 (location 7) (location 8) (location table) 
		 (on 1 table) (on 2 table) (on 3 4)
		 (on 4 1) (on 5 2) (on 6 table)
		 (on 7 6) (on 8 7)
		 (not (occupied 3)) (not (occupied 5))
		 (not (occupied 8)))
  (:goal (and (on 1 2) (on 2 table) 
			  (on 3 7) (on 4 5) (on 5 table)
			  (on 6 1) (on 7 table) (on 8 4))))


;; 11 blocks, 9 steps
(define (problem blw4)
  (:domain blw)
  (:objects 1 2 3 4 5 6 7 8 9 10 11 table)
  (:init (block 1) (block 2) (block 3) (block 4) 
		 (block 5) (block 6) (block 7) (block 8)
		 (block 9) (block 10) (block 11)
		 (location 1) (location 2) (location 3) 
		 (location 4) (location 5) (location 6) 
		 (location 7) (location 8) (location 9) 
		 (location 10) (location 11) (location table) 
		 (on 1 table) (on 2 1) (on 3 2)
		 (on 4 table) (on 5 4) (on 6 table)
		 (on 7 6) (on 8 7) (on 9 8) (on 10 5)
		 (on 11 10)
		 (not (occupied 3)) (not (occupied 11))
		 (not (occupied 9)))
  (:goal (and (on 1 5) (on 2 3) 
			  (on 3 11) (on 4 table) (on 5 10)
			  (on 6 table) (on 7 6) (on 8 9)
			  (on 9 4) (on 10 table) (on 11 7))))

;; 11 blocks, 11 steps
(define (problem blw5)
  (:domain blw)
  (:objects 1 2 3 4 5 6 7 8 9 10 11 table)
  (:init (block 1) (block 2) (block 3) (block 4) 
		 (block 5) (block 6) (block 7) (block 8)
		 (block 9) (block 10) (block 11)
		 (location 1) (location 2) (location 3) 
		 (location 4) (location 5) (location 6) 
		 (location 7) (location 8) (location 9) 
		 (location 10) (location 11) (location table) 
		 (on 1 table) (on 2 1) (on 3 2)
		 (on 4 table) (on 5 4) (on 6 table)
		 (on 7 6) (on 8 7) (on 9 8) (on 10 5)
		 (on 11 10)
		 (not (occupied 3)) (not (occupied 11))
		 (not (occupied 9)))
  (:goal (and (on 1 5) (on 2 3) 
			  (on 3 11) (on 4 table) (on 5 10)
			  (on 6 7) (on 7 table) (on 8 9)
			  (on 9 4) (on 10 table) (on 11 6))))