(in-package :domains)

(define (domain mbp)
  (:requirements :strips :equality)
  (:action walk
	     :parameters (?l2)
	     :precondition (and (location ?l1) (location ?l2)
							(at monkey ?l1) 
							(not (= ?l1 ?l2)) (not (on_box)))
	     :effect (and (not (at monkey ?l1)) (at monkey ?l2)))
  
  (:action climb_box
	     :parameters ()
	     :precondition (and (location ?l) (at box ?l) (at monkey ?l)
							(not (on_box)))
	     :effect (on_box))
  
  (:action push_box
	     :parameters (?l2)
	     :precondition (and (location ?l1) (location ?l2) 
							(not (= ?l1 ?l2)) 
							(at box ?l1) (at monkey ?l1) 
							(not (on_box)))
	     :effect (and (at monkey ?l2) (at box ?l2)
					  (not (at box ?l1)) (not (at monkey ?l1))))
 
  (:action grasp_bananas
	     :parameters ()
	     :precondition (and (location ?l) (at bananas ?l) (on_box)
							(at monkey ?l))
	     :effect (has_bananas)))
      
(define (problem mbp)
  (:domain mbp)
  (:objects l1 l2 l3)
  (:init (location l1) (location l2) (location l3)
	 (at monkey l1) (at box l2) (at bananas l3)
	 (not (at monkey l2)) (not (at box l1))
	 (not (at monkey l3)) (not (at box l3))
	 (not (at bananas l1)) (not (at bananas l2))
	 (not (on_box)))
  (:goal (has_bananas)))