;; This is a variation of the sick domain, 
;; from Weld et al. 1998
(in-package :domains)

(define (domain sick_2)
    (:requirements :conditional-effects :sensing)
  
  ;; There are several kinds of illnesses.
  (:constants I1 I2)

  (:action stain
	   :parameters ()
	   :precondition ()
	   :effect (and (when (I1) (C1))
			(when (I2) (C2))))

  (:action inspect
	   :parameters ()
	   :precondition ()
	   :effect (and (observes (C1))
			(observes (C2))))
  
	   
  ;; We can cure any illness, but using the wrong cure is fatal.
  (:action medicate
	   :parameters (?ill)
	   :precondition (object ?ill)
	   :effect (and (when (?ill) (not (?ill)))
			(when (not (?ill)) (D)))))

(define (problem sick_2)
  (:domain sick_2)
  (:init (not (C1)) (not (C2)) 
	 (oneof (I1) (I2))
	 (not (D)))
  (:goal (and (not (D))
	      (not (I1)) (not (I2)))))

(define (domain sick_4)
    (:requirements :conditional-effects :sensing)
  
  ;; There are several kinds of illnesses.
  (:constants I1 I2 I3 I4)

  (:action stain
	   :parameters ()
	   :precondition ()
	   :effect (and (when (I1) (C1))
			(when (I2) (C2))
			(when (I3) (C3))
			(when (I4) (C4))))

  (:action inspect
	   :parameters ()
	   :precondition ()
	   :effect (and (observes (C1))
			(observes (C2))
			(observes (C3))
			(observes (C4))))
  
	   
  ;; We can cure any illness, but using the wrong cure is fatal.
  (:action medicate
	   :parameters (?ill)
	   :precondition (object ?ill)
	   :effect (and (when (?ill) (not (?ill)))
			(when (not (?ill)) (D)))))

(define (problem sick_4)
  (:domain sick_4)
  (:init (not (C1)) (not (C2)) (not (C3))
	 (not (C4))
	 (oneof (I1) (I2) (I3) (I4))
	 (not (D)))
  (:goal (and (not (D))
	      (not (I1)) (not (I2)) 
	      (not (I3)) (not (I4)))))

(define (domain sick_6)
    (:requirements :conditional-effects :sensing)
  
  ;; There are several kinds of illnesses.
  (:constants I1 I2 I3 I4 I5 I6)

  (:action stain
	   :parameters ()
	   :precondition ()
	   :effect (and (when (I1) (C1))
			(when (I2) (C2))
			(when (I3) (C3))
			(when (I4) (C4))
			(when (I5) (C5))
			(when (I6) (C6))))

  (:action inspect
	   :parameters ()
	   :precondition ()
	   :effect (and (observes (C1))
			(observes (C2))
			(observes (C3))
			(observes (C4))
			(observes (C5))
			(observes (C6))))
  
	   
  ;; We can cure any illness, but using the wrong cure is fatal.
  (:action medicate
	   :parameters (?ill)
	   :precondition (object ?ill)
	   :effect (and (when (?ill) (not (?ill)))
			(when (not (?ill)) (D)))))

(define (problem sick_6)
  (:domain sick_6)
  (:init (not (C1)) (not (C2)) (not (C3))
	 (not (C4)) (not (C5)) (not (C6))
	 (oneof (I1) (I2) (I3) (I4) (I5) (I6))
	 (not (D)))
  (:goal (and (not (D))
	      (not (I1)) (not (I2)) (not (I3))
	      (not (I4)) (not (I5)) (not (I6)))))

(define (domain sick_8)
    (:requirements :conditional-effects :sensing)
  
  ;; There are several kinds of illnesses.
  (:constants I1 I2 I3 I4 I5 I6 I7 I8)

  (:action stain
	   :parameters ()
	   :precondition ()
	   :effect (and (when (I1) (C1))
			(when (I2) (C2))
			(when (I3) (C3))
			(when (I4) (C4))
			(when (I5) (C5))
			(when (I6) (C6))
			(when (I7) (C7))
			(when (I8) (C8))))

  (:action inspect
	   :parameters ()
	   :precondition ()
	   :effect (and (observes (C1))
			(observes (C2))
			(observes (C3))
			(observes (C4))
			(observes (C5))
			(observes (C6))
			(observes (C7))
			(observes (C8))))
  
	   
  ;; We can cure any illness, but using the wrong cure is fatal.
  (:action medicate
	   :parameters (?ill)
	   :precondition (object ?ill)
	   :effect (and (when (?ill) (not (?ill)))
			(when (not (?ill)) (D)))))

(define (problem sick_8)
  (:domain sick_8)
  (:init (not (C1)) (not (C2)) (not (C3))
	 (not (C4)) (not (C5)) (not (C6))
	 (not (C7)) (not (C8))
	 (oneof (I1) (I2) (I3) (I4) (I5) (I6)
		(I7) (I8))
	 (not (D)))
  (:goal (and (not (D))
	      (not (I1)) (not (I2)) (not (I3))
	      (not (I4)) (not (I5)) (not (I6))
	      (not (I7)) (not (I8)))))


(define (domain sick_10)
    (:requirements :conditional-effects :sensing)
  
  ;; There are several kinds of illnesses.
  (:constants I1 I2 I3 I4 I5 I6 I7 I8 I9 I10)

  (:action stain
	   :parameters ()
	   :precondition ()
	   :effect (and (when (I1) (C1))
			(when (I2) (C2))
			(when (I3) (C3))
			(when (I4) (C4))
			(when (I5) (C5))
			(when (I6) (C6))
			(when (I7) (C7))
			(when (I8) (C8))
			(when (I9) (C9))
			(when (I10) (C10))))

  (:action inspect
	   :parameters ()
	   :precondition ()
	   :effect (and (observes (C1))
			(observes (C2))
			(observes (C3))
			(observes (C4))
			(observes (C5))
			(observes (C6))
			(observes (C7))
			(observes (C8))
			(observes (C9))
			(observes (C10))))
  
	   
  ;; We can cure any illness, but using the wrong cure is fatal.
  (:action medicate
	   :parameters (?ill)
	   :precondition (object ?ill)
	   :effect (and (when (?ill) (not (?ill)))
			(when (not (?ill)) (D)))))

(define (problem sick_10)
  (:domain sick_10)
  (:init (not (C1)) (not (C2)) (not (C3))
	 (not (C4)) (not (C5)) (not (C6))
	 (not (C7)) (not (C8)) (not (C9)) (not (C10))
	 (oneof (I1) (I2) (I3) (I4) (I5) (I6)
		(I7) (I8) (I9) (I10))
	 (not (D)))
  (:goal (and (not (D))
	      (not (I1)) (not (I2)) (not (I3))
	      (not (I4)) (not (I5)) (not (I6))
	      (not (I7)) (not (I8)) (not (I9))
	      (not I10))))

